;;; -*- lexical-binding: t -*-
;;
;;   _________________________________________
;;  |  _____     _____        _      _     _  |
;;  | |  __ \   |  __ \      / \    | | _ | | |
;;  | | |  | |  | |__) |    / _ \   | |/ \| | |
;;  | | |__| |  |  __ <    / ___ \  |   _   | |
;;  | |_____/   |_/  \_\  /_/   \_\ |__/ \__| |
;;  |                                         |
;;  | dorks run away in the face of a warrior |
;;  |_________________________________________|
;;
;; by incal <incal@dataswamp.org> 2024.
;;
;; To try, if you didn't do 'run-from-file', first do
;;
;;   M-x eval-buffer RET
;;
;; then, do either of
;;
;;   M-x bad-snake   RET
;;   M-x bad-toronto RET
;;   M-x bad-egypt   RET
;;   M-x bad-studio  RET
;;
;; Or (recommended) use the 'run' scripts found in the same
;; directory as this file.

(require 'cl-lib)
(cl-pushnew "." load-path :test #'string=)
(require 'bad-paths)

(require 'bad-egypt)
(require 'bad-studio)
(require 'bad-toronto)
(require 'bad-snake-game)

(defun bad-egypt ()
  (interactive)
  (run (egypt)))

(defun bad-studio ()
  (interactive)
  (run (studio)))

(defun bad-toronto ()
  (interactive)
  (run (toronto)))

(defun bad-snake ()
  (interactive)
  (run (snake-game)))

(defalias 'bad #'bad-studio)

(provide 'bad)
