;;; -*- lexical-binding: t -*-

(require 'eieio)

(require 'bad-ascii)
(require 'bad-elem)
(require 'bad-pos)
(require 'bad-write)

(defclass abc (ascii)
  ((name :initform "abc")
   (dl :name "d" :initarg :dl :type (or null ascii) :initform nil)
   (rl :name "r" :initarg :rl :type (or null ascii) :initform nil)
   (al :name "a" :initarg :al :type (or null ascii) :initform nil)
   (wl :name "w" :initarg :wl :type (or null ascii) :initform nil)))

(cl-defmethod draw-draw ((a abc) (e elem) &optional x y)
  (with-slots (dl rl al wl) a
    (when (or x y)
      (let ((dist (1+ (oref wl w))))
        (pos dl    x             y)
        (pos rl (+ x      dist)  y)
        (pos al (+ x (* 2 dist)) y)
        (pos wl (+ x (* 3 dist)) y)))
    (write-over e dl)
    (write-over e rl)
    (write-over e al)
    (write-over e wl)))

(cl-defmethod init ((a abc))
  (with-slots (dl rl al wl) a
    (setf dl (ascii :name "d"))
    (setf rl (ascii :name "r"))
    (setf al (ascii :name "a"))
    (setf wl (ascii :name "w"))
    (let ((dir (file-name-concat "data" "abc")))
      (read-file dl nil dir)
      (read-file rl nil dir)
      (read-file al nil dir)
      (read-file wl nil dir))))

(provide 'bad-abc)
