;;; -*- lexical-binding: t -*-

(require 'eieio)
(require 'bad-ascii)

(defclass caption (ascii)
  ((name     :initform (format "caption-%d" (random 100)))
   (text     :initarg :text     :type string :initform "")
   (text-alt :initarg :text-alt :type string :initform "")))

(cl-defmethod switch ((c caption))
  (with-slots (data len text text-alt) c
    (cl-rotatef text text-alt)
  (draw c t)))

(cl-defmethod draw ((c caption) &optional force)
  (with-slots (data len text w h) c
    (when (or force (not data))
      (setf data (string-to-list text))
      (setf len #1=(length data))
      (when (or (= h 1) (zerop w))
        (setf w #1#))
      (when (zerop h)
        (setf h 1)))))

(provide 'bad-caption)
