;;; -*- lexical-binding: t -*-

(require 'eieio)

(require 'bad-borderless)
(require 'bad-move)

(defclass box (borderless)
  ((name :initform (format "box-%d" (random 100)))
   (c1   :initarg :c1 :type integer :initform #1=?+)
   (c2   :initarg :c2 :type integer :initform #1#)
   (c3   :initarg :c3 :type integer :initform #1#)
   (c4   :initarg :c4 :type integer :initform #1#)
   (s1   :initarg :s1 :type list    :initform #2=(list ?-))
   (s2   :initarg :s2 :type list    :initform #3=(list ?|))
   (s3   :initarg :s3 :type list    :initform #2#)
   (s4   :initarg :s4 :type list    :initform #3#)))

(cl-defmethod resize-sub :after ((b box))
  (with-slots (sub w h pushy) b
    (dolist (s sub)
      (with-slots (w-min h-min (sw w) (sh h) w-max h-max
                   min-x min-y x y           max-x max-y)
          s
        (setf w-max (max w-min #1=(- w 2)))
        (setf h-max (max h-min #2=(- h 2)))
        (setf max-x (max min-x #1#))
        (setf max-y (max min-y #2#))
        (when pushy
          (when (< w-max sw)
            (setf sw (max w-min w-max)))
          (when (< h-max sh)
            (setf sh (max h-min h-max)))
          (when (< w-max (- (+ x sw) min-x))
            (mov-x s -1))
          (when (< h-max (- (+ y sh) min-y))
            (mov-y s -1)))))))

(cl-defmethod border ((b box) c)
  (with-slots (c1 c2 c3 c4 s1 s2 s3 s4) b
    (setf c1 c)
    (setf c2 c)
    (setf c3 c)
    (setf c4 c)
    (setf s1 `(,c))
    (setf s2 `(,c))
    (setf s3 `(,c))
    (setf s4 `(,c))))

(cl-defmethod side ((b box) n s)
  (when (and (stringp s)
             (not (zerop (length s))))
    (with-slots (s1 s2 s3 s4) b
      (let ((lst (string-to-list s)))
        (cl-case n
          (1 (setf s1 lst))
          (2 (setf s2 lst))
          (3 (setf s3 lst))
          (4 (setf s4 lst))
          (_ (message "DNC")))))))

(cl-defmethod corner ((b box) n c)
  (with-slots (c1 c2 c3 c4) b
    (cl-case n
      (1 (setf c1 c))
      (2 (setf c2 c))
      (3 (setf c3 c))
      (4 (setf c4 c))
      (_ (message "DNC")))))

(cl-defmethod add ((b box) (e elem))
  (with-slots (w h sub pushy) b
    (setf pushy t)
    (with-slots ((iw w) (ih h) w-max h-max x y min-x min-y) e
      (setf iw #1=(- h 2))
      (setf ih #1#)
      (setf w-max (- w 2))
      (setf h-max #1#)
      (setf x #3=1)
      (setf y #4=1)
      (setf min-x #3#)
      (setf min-y #4#))
    (draw e)
    (push e sub)
    e))

(provide 'bad-box)
