;;; -*- lexical-binding: t -*-

(require 'eieio)

(require 'bad-mode-buffer)
(require 'bad-elem)

(cl-defmethod draw ((_ elem)) (ignore))

(cl-defmethod visible ((e elem) &optional set-to)
  (or set-to (setq set-to 0))
  (with-slots (visible) e
    (cl-case set-to
      (1 (setf visible t))
      (0 (setf visible (not visible)))
      (_ (setf visible nil)))))

(cl-defmethod draw-to-buf ((e elem))
  (with-slots (data w h visible) e
    (when visible
      (let ((buf (bad-mode-buffer)))
        (with-current-buffer buf
          (erase-buffer)
          (cl-loop
           with chunks = (take h (seq-split data w))
           for c in chunks
           for s = (seq--into-string c) do
           (insert (format "%s\n" s))))
        (pop-to-buffer buf)
        (goto-char (point-min))))))

(provide 'bad-draw)
