;;; -*- lexical-binding: t -*-

(require 'eieio)

(require 'bad-elem)
(require 'bad-pos)

(cl-defmethod mov ((e elem) (dx integer) (dy integer))
  (with-slots (x y) e
    (pos e (+ dx x) (+ dy y))))

;; -----------------------------------------------------------------------

(cl-defmethod mov-x ((e elem) &optional d)
  (or d (setq d 1))
  (mov e d 0))

(cl-defmethod mov-y ((e elem) &optional d)
  (or d (setq d 1))
  (mov e 0 d))

;; -----------------------------------------------------------------------

(cl-defmethod up ((e elem) &optional d)
  (or d (setq d 1))
  (mov-y e (- d)))

(cl-defmethod down ((e elem) &optional d)
  (or d (setq d 1))
  (mov-y e d))

(cl-defmethod left ((e elem) &optional d)
  (or d (setq d 1))
  (mov-x e (- d)))

(cl-defmethod right ((e elem) &optional d)
  (or d (setq d 1))
  (mov-x e d))

(provide 'bad-move)
